<?xml version="1.0" encoding="UTF-8"?>
<grammar datatypeLibrary="http://www.w3.org/2001/XMLSchema-datatypes" xmlns="http://relaxng.org/ns/structure/1.0" xmlns:a="http://relaxng.org/ns/compatibility/annotations/1.0" xmlns:number="http://openoffice.org/2000/datastyle" xmlns:form="http://openoffice.org/2000/form" xmlns:math="http://www.w3.org/1998/Math/MathML" xmlns:dr3d="http://openoffice.org/2000/dr3d" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:office="http://openoffice.org/2000/office" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:draw="http://openoffice.org/2000/drawing" xmlns:meta="http://openoffice.org/2000/meta" xmlns:text="http://openoffice.org/2000/text" xmlns:chart="http://openoffice.org/2000/chart" xmlns:svg="http://www.w3.org/2000/svg" xmlns:style="http://openoffice.org/2000/style" xmlns:table="http://openoffice.org/2000/table" xmlns:presentation="http://openoffice.org/2001/presentation" xmlns:config="http://openoffice.org/2001/config" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:script="http://openoffice.org/2000/script">
<!--
	$Id: text.mod,v 1.52 2002/09/30 09:33:38 mib Exp $

   The Contents of this file are made available subject to the terms of
   either of the following licenses
 
          - GNU Lesser General Public License Version 2.1
          - Sun Industry Standards Source License Version 1.1
 
   Sun Microsystems Inc., October, 2000
 
   GNU Lesser General Public License Version 2.1
   =============================================
   Copyright 2000 by Sun Microsystems, Inc.
   901 San Antonio Road, Palo Alto, CA 94303, USA
 
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License version 2.1, as published by the Free Software Foundation.
 
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
 
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA  02111-1307  USA
 
 
   Sun Industry Standards Source License Version 1.1
   =================================================
   The contents of this file are subject to the Sun Industry Standards
   Source License Version 1.1 (the "License"); You may not use this file
   except in compliance with the License. You may obtain a copy of the
   License at http://www.openoffice.org/license.html.
 
   Software provided under this License is provided on an "AS IS" basis,
   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
   See the License for the specific provisions governing your rights and
   obligations concerning the Software.
 
   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 
   Copyright: 2000 by Sun Microsystems, Inc.
 
   All Rights Reserved.
 
   Contributor(s): _______________________________________

-->
  <define name="fields">
    <choice>
      <ref name="text.date"/>
      <ref name="text.time"/>
      <ref name="text.page-number"/>
      <ref name="text.page-continuation"/>
      <ref name="text.sender-firstname"/>
      <ref name="text.sender-lastname"/>
      <ref name="text.sender-initials"/>
      <ref name="text.sender-title"/>
      <ref name="text.sender-position"/>
      <ref name="text.sender-email"/>
      <ref name="text.sender-phone-private"/>
      <ref name="text.sender-fax"/>
      <ref name="text.sender-company"/>
      <ref name="text.sender-phone-work"/>
      <ref name="text.sender-street"/>
      <ref name="text.sender-city"/>
      <ref name="text.sender-postal-code"/>
      <ref name="text.sender-country"/>
      <ref name="text.sender-state-or-province"/>
      <ref name="text.author-name"/>
      <ref name="text.author-initials"/>
      <ref name="text.placeholder"/>
      <ref name="text.variable-set"/>
      <ref name="text.variable-get"/>
      <ref name="text.variable-input"/>
      <ref name="text.user-field-get"/>
      <ref name="text.user-field-input"/>
      <ref name="text.sequence"/>
      <ref name="text.expression"/>
      <ref name="text.text-input"/>
      <ref name="text.database-display"/>
      <ref name="text.database-next"/>
      <ref name="text.database-row-select"/>
      <ref name="text.database-row-number"/>
      <ref name="text.database-name"/>
      <ref name="text.initial-creator"/>
      <ref name="text.creation-date"/>
      <ref name="text.creation-time"/>
      <ref name="text.description"/>
      <ref name="text.user-defined"/>
      <ref name="text.print-time"/>
      <ref name="text.print-date"/>
      <ref name="text.printed-by"/>
      <ref name="text.title"/>
      <ref name="text.subject"/>
      <ref name="text.keywords"/>
      <ref name="text.editing-cycles"/>
      <ref name="text.editing-duration"/>
      <ref name="text.modification-time"/>
      <ref name="text.modification-date"/>
      <ref name="text.creator"/>
      <ref name="text.conditional-text"/>
      <ref name="text.hidden-text"/>
      <ref name="text.hidden-paragraph"/>
      <ref name="text.chapter"/>
      <ref name="text.file-name"/>
      <ref name="text.template-name"/>
      <ref name="text.page-variable-set"/>
      <ref name="text.page-variable-get"/>
      <ref name="text.execute-macro"/>
      <ref name="text.dde-connection"/>
      <ref name="text.reference-ref"/>
      <ref name="text.sequence-ref"/>
      <ref name="text.bookmark-ref"/>
      <ref name="text.footnote-ref"/>
      <ref name="text.endnote-ref"/>
      <ref name="text.sheet-name"/>
      <ref name="text.bibliography-mark"/>
      <ref name="text.page-count"/>
      <ref name="text.paragraph-count"/>
      <ref name="text.word-count"/>
      <ref name="text.character-count"/>
      <ref name="text.table-count"/>
      <ref name="text.image-count"/>
      <ref name="text.object-count"/>
      <ref name="office.annotation"/>
      <ref name="text.script"/>
      <ref name="text.measure"/>
    </choice>
  </define>
  <define name="inline-text-elements">
    <choice>
      <ref name="text.span"/>
      <ref name="text.tab-stop"/>
      <ref name="text.s"/>
      <ref name="text.line-break"/>
      <ref name="text.footnote"/>
      <ref name="text.endnote"/>
      <ref name="text.a"/>
      <ref name="text.bookmark"/>
      <ref name="text.bookmark-start"/>
      <ref name="text.bookmark-end"/>
      <ref name="text.reference-mark"/>
      <ref name="text.reference-mark-start"/>
      <ref name="text.reference-mark-end"/>
      <ref name="fields"/>
      <ref name="shape"/>
      <ref name="text.toc-mark-start"/>
      <ref name="text.toc-mark-end"/>
      <ref name="text.toc-mark"/>
      <ref name="text.user-index-mark-start"/>
      <ref name="text.user-index-mark-end"/>
      <ref name="text.user-index-mark"/>
      <ref name="text.alphabetical-index-mark-start"/>
      <ref name="text.alphabetical-index-mark-end"/>
      <ref name="text.alphabetical-index-mark"/>
      <ref name="change-marks"/>
      <ref name="draw.a"/>
      <ref name="text.ruby"/>
    </choice>
  </define>
  <define name="inline-text">
    <zeroOrMore>
      <choice>
        <text/>
        <ref name="inline-text-elements"/>
      </choice>
    </zeroOrMore>
  </define>
  <define name="text.p">
    <element name="text:p">
      <ref name="text.p-attlist"/>
      <ref name="inline-text"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.p"/>
  </define>
  <define name="text.h">
    <element name="text:h">
      <ref name="text.h-attlist"/>
      <ref name="inline-text"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.h"/>
  </define>
  <define name="text.p-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.p-attlist" combine="interleave">
    <optional>
      <attribute name="text:cond-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.h-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.h-attlist" combine="interleave">
    <optional>
      <attribute name="text:cond-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.h-attlist" combine="interleave">
    <optional>
      <attribute name="text:level" a:defaultValue="1">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="text.span">
    <element name="text:span">
      <ref name="text.span-attlist"/>
      <ref name="inline-text"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.span"/>
  </define>
  <define name="text.span-attlist" combine="interleave">
    <attribute name="text:style-name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="text.a">
    <element name="text:a">
      <ref name="text.a-attlist"/>
      <zeroOrMore>
        <choice>
          <text/>
          <ref name="office.events"/>
          <ref name="inline-text-elements"/>
        </choice>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.a"/>
  </define>
  <define name="text.a-attlist" combine="interleave">
    <attribute name="xlink:href">
      <ref name="uriReference"/>
    </attribute>
  </define>
  <define name="text.a-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type" a:defaultValue="simple">
        <value>simple</value>
      </attribute>
    </optional>
  </define>
  <define name="text.a-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:actuate" a:defaultValue="onRequest">
        <choice>
          <value>onRequest</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.a-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show" a:defaultValue="replace">
        <choice>
          <value>new</value>
          <value>replace</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.a-attlist" combine="interleave">
    <optional>
      <attribute name="office:name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.a-attlist" combine="interleave">
    <optional>
      <attribute name="office:target-frame-name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.a-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.a-attlist" combine="interleave">
    <optional>
      <attribute name="text:visited-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.s">
    <element name="text:s">
      <ref name="text.s-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.s"/>
  </define>
  <define name="text.s-attlist" combine="interleave">
    <optional>
      <attribute name="text:c" a:defaultValue="1">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="text.tab-stop">
    <element name="text:tab-stop">
      <ref name="text.tab-stop-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="text.tab-stop-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.tab-stop"/>
  </define>
  <define name="text.line-break">
    <element name="text:line-break">
      <ref name="text.line-break-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="text.line-break-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.line-break"/>
  </define>
  <define name="list-items">
    <choice>
      <group>
        <ref name="text.list-header"/>
        <zeroOrMore>
          <ref name="text.list-item"/>
        </zeroOrMore>
      </group>
      <oneOrMore>
        <ref name="text.list-item"/>
      </oneOrMore>
    </choice>
  </define>
  <define name="text.ordered-list">
    <element name="text:ordered-list">
      <ref name="text.ordered-list-attlist"/>
      <ref name="list-items"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.ordered-list"/>
  </define>
  <define name="text.unordered-list">
    <element name="text:unordered-list">
      <ref name="text.unordered-list-attlist"/>
      <ref name="list-items"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.unordered-list"/>
  </define>
  <define name="text.ordered-list-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.unordered-list-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.ordered-list-attlist" combine="interleave">
    <optional>
      <attribute name="text:continue-numbering" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.list-header">
    <element name="text:list-header">
      <ref name="text.list-header-attlist"/>
      <oneOrMore>
        <choice>
          <ref name="text.p"/>
          <ref name="text.h"/>
        </choice>
      </oneOrMore>
    </element>
  </define>
  <define name="text.list-header-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.list-header"/>
  </define>
  <define name="text.list-item">
    <element name="text:list-item">
      <ref name="text.list-item-attlist"/>
      <oneOrMore>
        <choice>
          <ref name="text.p"/>
          <ref name="text.h"/>
          <ref name="text.ordered-list"/>
          <ref name="text.unordered-list"/>
        </choice>
      </oneOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.list-item"/>
  </define>
  <define name="text.list-item-attlist" combine="interleave">
    <optional>
      <attribute name="text:restart-numbering" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.list-item-attlist" combine="interleave">
    <optional>
      <attribute name="text:start-value">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="text.list-style">
    <element name="text:list-style">
      <ref name="text.list-style-attlist"/>
      <oneOrMore>
        <choice>
          <ref name="text.list-level-style-number"/>
          <ref name="text.list-level-style-bullet"/>
          <ref name="text.list-level-style-image"/>
        </choice>
      </oneOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.list-style"/>
  </define>
  <define name="text.list-style-attlist" combine="interleave">
    <optional>
      <attribute name="style:name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.list-style-attlist" combine="interleave">
    <optional>
      <attribute name="text:consecutive-numbering" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.list-level-style-number">
    <element name="text:list-level-style-number">
      <ref name="text.list-level-style-number-attlist"/>
      <optional>
        <ref name="style.properties"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.list-level-style-number"/>
  </define>
  <define name="text.list-level-style-number-attlist" combine="interleave">
    <attribute name="text:level">
      <ref name="positiveInteger"/>
    </attribute>
  </define>
  <define name="text.list-level-style-number-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.list-level-style-number-attlist" combine="interleave">
    <attribute name="style:num-format">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.list-level-style-number-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-prefix">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.list-level-style-number-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-suffix">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.list-level-style-number-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-letter-sync" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.list-level-style-number-attlist" combine="interleave">
    <optional>
      <attribute name="text:display-levels" a:defaultValue="1">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="text.list-level-style-number-attlist" combine="interleave">
    <optional>
      <attribute name="text:start-value" a:defaultValue="1">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="text.list-level-style-bullet">
    <element name="text:list-level-style-bullet">
      <ref name="text.list-level-style-bullet-attlist"/>
      <optional>
        <ref name="style.properties"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.list-level-style-bullet"/>
  </define>
  <define name="text.list-level-style-bullet-attlist" combine="interleave">
    <attribute name="text:level">
      <ref name="positiveInteger"/>
    </attribute>
  </define>
  <define name="text.list-level-style-bullet-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.list-level-style-bullet-attlist" combine="interleave">
    <attribute name="text:bullet-char">
      <ref name="character"/>
    </attribute>
  </define>
  <define name="text.list-level-style-bullet-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-prefix">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.list-level-style-bullet-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-suffix">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.list-level-style-image">
    <element name="text:list-level-style-image">
      <ref name="text.list-level-style-image-attlist"/>
      <optional>
        <ref name="style.properties"/>
      </optional>
      <optional>
        <ref name="office.binary-data"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.list-level-style-image"/>
  </define>
  <define name="text.list-level-style-image-attlist" combine="interleave">
    <attribute name="text:level">
      <ref name="positiveInteger"/>
    </attribute>
  </define>
  <define name="text.list-level-style-image-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type">
        <choice>
          <value>simple</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.list-level-style-image-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:href">
        <ref name="uriReference"/>
      </attribute>
    </optional>
  </define>
  <define name="text.list-level-style-image-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:actuate">
        <choice>
          <value>onLoad</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.list-level-style-image-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>embed</value>
        </choice>
      </attribute>
    </optional>
  </define>
<!-- list properties -->
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="text:space-before">
        <ref name="nonNegativeLength"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="text:min-label-width">
        <ref name="nonNegativeLength"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="text:min-label-distance">
        <ref name="nonNegativeLength"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="text:enable-numbering">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="style:list-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.outline-style">
    <element name="text:outline-style">
      <ref name="text.outline-style-attlist"/>
      <oneOrMore>
        <ref name="text.outline-level-style"/>
      </oneOrMore>
    </element>
  </define>
  <define name="text.outline-style-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.outline-style"/>
  </define>
  <define name="text.outline-level-style">
    <element name="text:outline-level-style">
      <ref name="text.outline-level-style-attlist"/>
      <optional>
        <ref name="style.properties"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.outline-level-style"/>
  </define>
  <define name="text.outline-level-style-attlist" combine="interleave">
    <attribute name="text:level">
      <ref name="positiveInteger"/>
    </attribute>
  </define>
  <define name="text.outline-level-style-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.outline-level-style-attlist" combine="interleave">
    <attribute name="style:num-format">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.outline-level-style-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-prefix">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.outline-level-style-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-suffix">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.outline-level-style-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-letter-sync" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.outline-level-style-attlist" combine="interleave">
    <optional>
      <attribute name="text:display-levels" a:defaultValue="1">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="text.outline-level-style-attlist" combine="interleave">
    <optional>
      <attribute name="text:start-value" a:defaultValue="1">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="variableName">
    <data type="string"/>
  </define>
  <define name="formula">
    <data type="string"/>
  </define>
  <define name="valueAttr">
    <optional>
      <attribute name="text:value-type">
        <ref name="valueType"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="text:currency"/>
    </optional>
  </define>
  <define name="valueAndTypeAttr">
    <ref name="valueAttr"/>
    <optional>
      <attribute name="text:value">
        <ref name="float"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="text:date-value">
        <ref name="date"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="text:time-value">
        <ref name="timeInstance"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="text:boolean-value">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="text:string-value">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="numFormat">
    <optional>
      <attribute name="style:num-format"/>
    </optional>
    <optional>
      <attribute name="style:num-letter-sync" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.date">
    <element name="text:date">
      <ref name="text.date-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.date"/>
  </define>
  <define name="text.date-attlist" combine="interleave">
    <optional>
      <attribute name="text:date-value">
        <ref name="timeInstance"/>
      </attribute>
    </optional>
  </define>
  <define name="text.date-attlist" combine="interleave">
    <optional>
      <attribute name="text:date-adjust">
        <ref name="dateDuration"/>
      </attribute>
    </optional>
  </define>
  <define name="text.date-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.date-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.time">
    <element name="text:time">
      <ref name="text.time-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.time"/>
  </define>
  <define name="text.time-attlist" combine="interleave">
    <optional>
      <attribute name="text:time-value">
        <ref name="timeInstance"/>
      </attribute>
    </optional>
  </define>
  <define name="text.time-attlist" combine="interleave">
    <optional>
      <attribute name="text:time-adjust">
        <ref name="timeDuration"/>
      </attribute>
    </optional>
  </define>
  <define name="text.time-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.time-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.page-number">
    <element name="text:page-number">
      <ref name="text.page-number-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.page-number"/>
  </define>
  <define name="text.page-number-attlist" combine="interleave">
    <optional>
      <attribute name="text:page-adjust">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="text.page-number-attlist" combine="interleave">
    <optional>
      <attribute name="text:select-page" a:defaultValue="current">
        <choice>
          <value>previous</value>
          <value>current</value>
          <value>next</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.page-number-attlist" combine="interleave">
    <ref name="numFormat"/>
  </define>
  <define name="text.page-continuation">
    <element name="text:page-continuation">
      <ref name="text.page-continuation-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.page-continuation"/>
  </define>
  <define name="text.page-continuation-attlist" combine="interleave">
    <attribute name="text:select-page">
      <choice>
        <value>previous</value>
        <value>next</value>
      </choice>
    </attribute>
  </define>
  <define name="text.page-continuation-attlist" combine="interleave">
    <optional>
      <attribute name="text:string-value">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sender-firstname">
    <element name="text:sender-firstname">
      <ref name="text.sender-firstname-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sender-firstname"/>
  </define>
  <define name="text.sender-firstname-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sender-lastname">
    <element name="text:sender-lastname">
      <ref name="text.sender-lastname-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sender-lastname"/>
  </define>
  <define name="text.sender-lastname-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sender-initials">
    <element name="text:sender-initials">
      <ref name="text.sender-initials-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sender-initials"/>
  </define>
  <define name="text.sender-initials-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sender-title">
    <element name="text:sender-title">
      <ref name="text.sender-title-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sender-title"/>
  </define>
  <define name="text.sender-title-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sender-position">
    <element name="text:sender-position">
      <ref name="text.sender-position-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sender-position"/>
  </define>
  <define name="text.sender-position-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sender-email">
    <element name="text:sender-email">
      <ref name="text.sender-email-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sender-email"/>
  </define>
  <define name="text.sender-email-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sender-phone-private">
    <element name="text:sender-phone-private">
      <ref name="text.sender-phone-private-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sender-phone-private"/>
  </define>
  <define name="text.sender-phone-private-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sender-fax">
    <element name="text:sender-fax">
      <ref name="text.sender-fax-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sender-fax"/>
  </define>
  <define name="text.sender-fax-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sender-company">
    <element name="text:sender-company">
      <ref name="text.sender-company-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sender-company"/>
  </define>
  <define name="text.sender-company-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sender-phone-work">
    <element name="text:sender-phone-work">
      <ref name="text.sender-phone-work-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sender-phone-work"/>
  </define>
  <define name="text.sender-phone-work-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sender-street">
    <element name="text:sender-street">
      <ref name="text.sender-street-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sender-street"/>
  </define>
  <define name="text.sender-street-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sender-city">
    <element name="text:sender-city">
      <ref name="text.sender-city-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sender-city"/>
  </define>
  <define name="text.sender-city-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sender-postal-code">
    <element name="text:sender-postal-code">
      <ref name="text.sender-postal-code-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sender-postal-code"/>
  </define>
  <define name="text.sender-postal-code-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sender-country">
    <element name="text:sender-country">
      <ref name="text.sender-country-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sender-country"/>
  </define>
  <define name="text.sender-country-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sender-state-or-province">
    <element name="text:sender-state-or-province">
      <ref name="text.sender-state-or-province-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sender-state-or-province"/>
  </define>
  <define name="text.sender-state-or-province-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.author-name">
    <element name="text:author-name">
      <ref name="text.author-name-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.author-name"/>
  </define>
  <define name="text.author-name-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.author-initials">
    <element name="text:author-initials">
      <ref name="text.author-initials-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.author-initials"/>
  </define>
  <define name="text.author-initials-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.placeholder">
    <element name="text:placeholder">
      <ref name="text.placeholder-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.placeholder"/>
  </define>
  <define name="text.placeholder-attlist" combine="interleave">
    <attribute name="text:placeholder-type">
      <choice>
        <value>text</value>
        <value>table</value>
        <value>text-box</value>
        <value>image</value>
        <value>object</value>
      </choice>
    </attribute>
  </define>
  <define name="text.placeholder-attlist" combine="interleave">
    <optional>
      <attribute name="text:description">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.variable-decls">
    <element name="text:variable-decls">
      <ref name="text.variable-decls-attlist"/>
      <zeroOrMore>
        <ref name="text.variable-decl"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="text.variable-decls-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.variable-decls"/>
  </define>
  <define name="text.variable-decl">
    <element name="text:variable-decl">
      <ref name="text.variable-decl-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.variable-decl"/>
  </define>
  <define name="text.variable-decl-attlist" combine="interleave">
    <attribute name="text:name">
      <ref name="variableName"/>
    </attribute>
  </define>
  <define name="text.variable-decl-attlist" combine="interleave">
    <ref name="valueAndTypeAttr"/>
  </define>
  <define name="text.variable-set">
    <element name="text:variable-set">
      <ref name="text.variable-set-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.variable-set"/>
  </define>
  <define name="text.variable-set-attlist" combine="interleave">
    <attribute name="text:name">
      <ref name="variableName"/>
    </attribute>
  </define>
  <define name="text.variable-set-attlist" combine="interleave">
    <optional>
      <attribute name="text:formula">
        <ref name="formula"/>
      </attribute>
    </optional>
  </define>
  <define name="text.variable-set-attlist" combine="interleave">
    <ref name="valueAndTypeAttr"/>
  </define>
  <define name="text.variable-set-attlist" combine="interleave">
    <optional>
      <attribute name="text:display" a:defaultValue="value">
        <choice>
          <value>value</value>
          <value>none</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.variable-set-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.variable-get">
    <element name="text:variable-get">
      <ref name="text.variable-get-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.variable-get"/>
  </define>
  <define name="text.variable-get-attlist" combine="interleave">
    <attribute name="text:name">
      <ref name="variableName"/>
    </attribute>
  </define>
  <define name="text.variable-get-attlist" combine="interleave">
    <optional>
      <attribute name="text:display" a:defaultValue="value">
        <choice>
          <value>value</value>
          <value>formula</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.variable-get-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.variable-get-attlist" combine="interleave">
    <ref name="valueAttr"/>
  </define>
  <define name="text.variable-input">
    <element name="text:variable-input">
      <ref name="text.variable-input-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.variable-input"/>
  </define>
  <define name="text.variable-input-attlist" combine="interleave">
    <attribute name="text:name">
      <ref name="variableName"/>
    </attribute>
  </define>
  <define name="text.variable-input-attlist" combine="interleave">
    <optional>
      <attribute name="text:description">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.variable-input-attlist" combine="interleave">
    <ref name="valueAndTypeAttr"/>
  </define>
  <define name="text.variable-input-attlist" combine="interleave">
    <optional>
      <attribute name="text:display" a:defaultValue="value">
        <choice>
          <value>value</value>
          <value>none</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.variable-input-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-field-decls">
    <element name="text:user-field-decls">
      <ref name="text.user-field-decls-attlist"/>
      <zeroOrMore>
        <ref name="text.user-field-decl"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="text.user-field-decls-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.user-field-decls"/>
  </define>
  <define name="text.user-field-decl">
    <element name="text:user-field-decl">
      <ref name="text.user-field-decl-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.user-field-decl"/>
  </define>
  <define name="text.user-field-decl-attlist" combine="interleave">
    <attribute name="text:name">
      <ref name="variableName"/>
    </attribute>
  </define>
  <define name="text.user-field-decl-attlist" combine="interleave">
    <optional>
      <attribute name="text:formula">
        <ref name="formula"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-field-decl-attlist" combine="interleave">
    <ref name="valueAndTypeAttr"/>
  </define>
  <define name="text.user-field-get">
    <element name="text:user-field-get">
      <ref name="text.user-field-get-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.user-field-get"/>
  </define>
  <define name="text.user-field-get-attlist" combine="interleave">
    <attribute name="text:name">
      <ref name="variableName"/>
    </attribute>
  </define>
  <define name="text.user-field-get-attlist" combine="interleave">
    <optional>
      <attribute name="text:display" a:defaultValue="value">
        <choice>
          <value>value</value>
          <value>formula</value>
          <value>none</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.user-field-get-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-field-input">
    <element name="text:user-field-input">
      <ref name="text.user-field-input-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.user-field-input"/>
  </define>
  <define name="text.user-field-input-attlist" combine="interleave">
    <attribute name="text:name">
      <ref name="variableName"/>
    </attribute>
  </define>
  <define name="text.user-field-input-attlist" combine="interleave">
    <optional>
      <attribute name="text:description">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-field-input-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sequence-decls">
    <element name="text:sequence-decls">
      <ref name="text.sequence-decls-attlist"/>
      <zeroOrMore>
        <ref name="text.sequence-decl"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="text.sequence-decls-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sequence-decls"/>
  </define>
  <define name="text.sequence-decl">
    <element name="text:sequence-decl">
      <ref name="text.sequence-decl-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sequence-decl"/>
  </define>
  <define name="text.sequence-decl-attlist" combine="interleave">
    <attribute name="text:name">
      <ref name="variableName"/>
    </attribute>
  </define>
  <define name="text.sequence-decl-attlist" combine="interleave">
    <optional>
      <attribute name="text:display-outline-level" a:defaultValue="0">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sequence-decl-attlist" combine="interleave">
    <optional>
      <attribute name="text:separation-character" a:defaultValue=".">
        <ref name="character"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sequence">
    <element name="text:sequence">
      <ref name="text.sequence-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sequence"/>
  </define>
  <define name="text.sequence-attlist" combine="interleave">
    <attribute name="text:name">
      <ref name="variableName"/>
    </attribute>
  </define>
  <define name="text.sequence-attlist" combine="interleave">
    <optional>
      <attribute name="text:formula">
        <ref name="formula"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sequence-attlist" combine="interleave">
    <ref name="numFormat"/>
  </define>
  <define name="text.sequence-attlist" combine="interleave">
    <optional>
      <attribute name="text:ref-name">
        <data type="ID"/>
      </attribute>
    </optional>
  </define>
  <define name="text.expression">
    <element name="text:expression">
      <ref name="text.expression-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.expression"/>
  </define>
  <define name="text.expression-attlist" combine="interleave">
    <optional>
      <attribute name="text:formula">
        <ref name="formula"/>
      </attribute>
    </optional>
  </define>
  <define name="text.expression-attlist" combine="interleave">
    <optional>
      <attribute name="text:display" a:defaultValue="value">
        <choice>
          <value>value</value>
          <value>formula</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.expression-attlist" combine="interleave">
    <ref name="valueAndTypeAttr"/>
  </define>
  <define name="text.expression-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.text-input">
    <element name="text:text-input">
      <ref name="text.text-input-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.text-input"/>
  </define>
  <define name="text.text-input-attlist" combine="interleave">
    <optional>
      <attribute name="text:description">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="database-table">
    <attribute name="text:database-name"/>
    <attribute name="text:table-name"/>
    <optional>
      <attribute name="text:table-type">
        <choice>
          <value>table</value>
          <value>query</value>
          <value>command</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.database-display">
    <element name="text:database-display">
      <ref name="text.database-display-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.database-display"/>
  </define>
  <define name="text.database-display-attlist" combine="interleave">
    <ref name="database-table"/>
  </define>
  <define name="text.database-display-attlist" combine="interleave">
    <attribute name="text:column-name">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.database-display-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.database-next">
    <element name="text:database-next">
      <ref name="text.database-next-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.database-next"/>
  </define>
  <define name="text.database-next-attlist" combine="interleave">
    <ref name="database-table"/>
  </define>
  <define name="text.database-next-attlist" combine="interleave">
    <optional>
      <attribute name="text:condition">
        <ref name="formula"/>
      </attribute>
    </optional>
  </define>
  <define name="text.database-row-select">
    <element name="text:database-row-select">
      <ref name="text.database-row-select-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.database-row-select"/>
  </define>
  <define name="text.database-row-select-attlist" combine="interleave">
    <ref name="database-table"/>
  </define>
  <define name="text.database-row-select-attlist" combine="interleave">
    <optional>
      <attribute name="text:condition">
        <ref name="formula"/>
      </attribute>
    </optional>
  </define>
  <define name="text.database-row-select-attlist" combine="interleave">
    <attribute name="text:row-number">
      <ref name="integer"/>
    </attribute>
  </define>
  <define name="text.database-row-number">
    <element name="text:database-row-number">
      <ref name="text.database-row-number-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.database-row-number"/>
  </define>
  <define name="text.database-row-number-attlist" combine="interleave">
    <ref name="database-table"/>
  </define>
  <define name="text.database-row-number-attlist" combine="interleave">
    <ref name="numFormat"/>
  </define>
  <define name="text.database-row-number-attlist" combine="interleave">
    <optional>
      <attribute name="text:value">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="text.database-name">
    <element name="text:database-name">
      <ref name="text.database-name-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.database-name"/>
  </define>
  <define name="text.database-name-attlist" combine="interleave">
    <ref name="database-table"/>
  </define>
  <define name="text.initial-creator">
    <element name="text:initial-creator">
      <ref name="text.initial-creator-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.initial-creator"/>
  </define>
  <define name="text.initial-creator-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.creation-date">
    <element name="text:creation-date">
      <ref name="text.creation-date-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.creation-date"/>
  </define>
  <define name="text.creation-date-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.creation-date-attlist" combine="interleave">
    <optional>
      <attribute name="text:date-value">
        <ref name="date"/>
      </attribute>
    </optional>
  </define>
  <define name="text.creation-date-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.creation-time">
    <element name="text:creation-time">
      <ref name="text.creation-time-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.creation-time"/>
  </define>
  <define name="text.creation-time-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.creation-time-attlist" combine="interleave">
    <optional>
      <attribute name="text:time-value">
        <ref name="timeInstance"/>
      </attribute>
    </optional>
  </define>
  <define name="text.creation-time-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.description">
    <element name="text:description">
      <ref name="text.description-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.description"/>
  </define>
  <define name="text.description-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-defined">
    <element name="text:user-defined">
      <ref name="text.user-defined-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.user-defined"/>
  </define>
  <define name="text.user-defined-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-defined-attlist" combine="interleave">
    <attribute name="text:name">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.print-time">
    <element name="text:print-time">
      <ref name="text.print-time-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.print-time"/>
  </define>
  <define name="text.print-time-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.print-time-attlist" combine="interleave">
    <optional>
      <attribute name="text:time-value">
        <ref name="timeInstance"/>
      </attribute>
    </optional>
  </define>
  <define name="text.print-time-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.print-date">
    <element name="text:print-date">
      <ref name="text.print-date-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.print-date"/>
  </define>
  <define name="text.print-date-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.print-date-attlist" combine="interleave">
    <optional>
      <attribute name="text:date-value">
        <ref name="date"/>
      </attribute>
    </optional>
  </define>
  <define name="text.print-date-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.printed-by">
    <element name="text:printed-by">
      <ref name="text.printed-by-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.printed-by"/>
  </define>
  <define name="text.printed-by-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.title">
    <element name="text:title">
      <ref name="text.title-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.title"/>
  </define>
  <define name="text.title-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.subject">
    <element name="text:subject">
      <ref name="text.subject-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.subject"/>
  </define>
  <define name="text.subject-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.keywords">
    <element name="text:keywords">
      <ref name="text.keywords-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.keywords"/>
  </define>
  <define name="text.keywords-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.editing-cycles">
    <element name="text:editing-cycles">
      <ref name="text.editing-cycles-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.editing-cycles"/>
  </define>
  <define name="text.editing-cycles-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.editing-duration">
    <element name="text:editing-duration">
      <ref name="text.editing-duration-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.editing-duration"/>
  </define>
  <define name="text.editing-duration-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.editing-duration-attlist" combine="interleave">
    <optional>
      <attribute name="text:duration">
        <ref name="timeDuration"/>
      </attribute>
    </optional>
  </define>
  <define name="text.editing-duration-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.modification-time">
    <element name="text:modification-time">
      <ref name="text.modification-time-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.modification-time"/>
  </define>
  <define name="text.modification-time-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.modification-time-attlist" combine="interleave">
    <optional>
      <attribute name="text:time-value">
        <ref name="timeInstance"/>
      </attribute>
    </optional>
  </define>
  <define name="text.modification-time-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.modification-date">
    <element name="text:modification-date">
      <ref name="text.modification-date-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.modification-date"/>
  </define>
  <define name="text.modification-date-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.modification-date-attlist" combine="interleave">
    <optional>
      <attribute name="text:date-value">
        <ref name="date"/>
      </attribute>
    </optional>
  </define>
  <define name="text.modification-date-attlist" combine="interleave">
    <optional>
      <attribute name="style:data-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.creator">
    <element name="text:creator">
      <ref name="text.creator-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.creator"/>
  </define>
  <define name="text.creator-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.conditional-text">
    <element name="text:conditional-text">
      <ref name="text.conditional-text-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.conditional-text"/>
  </define>
  <define name="text.conditional-text-attlist" combine="interleave">
    <attribute name="text:condition">
      <ref name="formula"/>
    </attribute>
  </define>
  <define name="text.conditional-text-attlist" combine="interleave">
    <attribute name="text:string-value-if-false">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.conditional-text-attlist" combine="interleave">
    <attribute name="text:string-value-if-true">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.conditional-text-attlist" combine="interleave">
    <optional>
      <attribute name="text:current-value" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.hidden-text">
    <element name="text:hidden-text">
      <ref name="text.hidden-text-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.hidden-text"/>
  </define>
  <define name="text.hidden-text-attlist" combine="interleave">
    <attribute name="text:condition">
      <ref name="formula"/>
    </attribute>
  </define>
  <define name="text.hidden-text-attlist" combine="interleave">
    <attribute name="text:string-value">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.hidden-text-attlist" combine="interleave">
    <optional>
      <attribute name="text:is-hidden" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.hidden-paragraph">
    <element name="text:hidden-paragraph">
      <ref name="text.hidden-paragraph-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.hidden-paragraph"/>
  </define>
  <define name="text.hidden-paragraph-attlist" combine="interleave">
    <attribute name="text:condition">
      <ref name="formula"/>
    </attribute>
  </define>
  <define name="text.hidden-paragraph-attlist" combine="interleave">
    <optional>
      <attribute name="text:is-hidden" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.chapter">
    <element name="text:chapter">
      <ref name="text.chapter-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.chapter"/>
  </define>
  <define name="text.chapter-attlist" combine="interleave">
    <optional>
      <attribute name="text:display" a:defaultValue="number-and-name">
        <choice>
          <value>name</value>
          <value>number</value>
          <value>number-and-name</value>
          <value>plain-number-and-name</value>
          <value>plain-number</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.chapter-attlist" combine="interleave">
    <optional>
      <attribute name="text:outline-level" a:defaultValue="1">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="text.file-name">
    <element name="text:file-name">
      <ref name="text.file-name-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.file-name"/>
  </define>
  <define name="text.file-name-attlist" combine="interleave">
    <optional>
      <attribute name="text:display" a:defaultValue="full">
        <choice>
          <value>full</value>
          <value>path</value>
          <value>name</value>
          <value>name-and-extension</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.file-name-attlist" combine="interleave">
    <optional>
      <attribute name="text:fixed" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.template-name">
    <element name="text:template-name">
      <ref name="text.template-name-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.template-name"/>
  </define>
  <define name="text.template-name-attlist" combine="interleave">
    <optional>
      <attribute name="text:display" a:defaultValue="full">
        <choice>
          <value>full</value>
          <value>path</value>
          <value>name</value>
          <value>name-and-extension</value>
          <value>area</value>
          <value>title</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.page-variable-set">
    <element name="text:page-variable-set">
      <ref name="text.page-variable-set-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.page-variable-set"/>
  </define>
  <define name="text.page-variable-set-attlist" combine="interleave">
    <optional>
      <attribute name="text:active" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.page-variable-set-attlist" combine="interleave">
    <optional>
      <attribute name="text:page-adjust" a:defaultValue="0">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="text.page-variable-get">
    <element name="text:page-variable-get">
      <ref name="text.page-variable-get-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.page-variable-get"/>
  </define>
  <define name="text.page-variable-get-attlist" combine="interleave">
    <ref name="numFormat"/>
  </define>
  <define name="text.execute-macro">
    <element name="text:execute-macro">
      <ref name="text.execute-macro-attlist"/>
      <zeroOrMore>
        <choice>
          <text/>
          <ref name="office.events"/>
        </choice>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.execute-macro"/>
  </define>
  <define name="text.execute-macro-attlist" combine="interleave">
    <optional>
      <attribute name="text:description">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.dde-connection-decls">
    <element name="text:dde-connection-decls">
      <ref name="text.dde-connection-decls-attlist"/>
      <zeroOrMore>
        <ref name="text.dde-connection-decl"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="text.dde-connection-decls-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.dde-connection-decls"/>
  </define>
  <define name="text.dde-connection-decl">
    <element name="text:dde-connection-decl">
      <ref name="text.dde-connection-decl-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.dde-connection-decl"/>
  </define>
  <define name="text.dde-connection-decl-attlist" combine="interleave">
    <attribute name="text:name">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.dde-connection-decl-attlist" combine="interleave">
    <attribute name="office:dde-application">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.dde-connection-decl-attlist" combine="interleave">
    <attribute name="office:dde-topic">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.dde-connection-decl-attlist" combine="interleave">
    <attribute name="office:dde-item">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.dde-connection-decl-attlist" combine="interleave">
    <optional>
      <attribute name="office:automatic-update" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.dde-connection">
    <element name="text:dde-connection">
      <ref name="text.dde-connection-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.dde-connection"/>
  </define>
  <define name="text.dde-connection-attlist" combine="interleave">
    <attribute name="text:connection-name">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.reference-ref">
    <element name="text:reference-ref">
      <ref name="text.reference-ref-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.reference-ref"/>
  </define>
  <define name="text.reference-ref-attlist" combine="interleave">
    <attribute name="text:ref-name">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.reference-ref-attlist" combine="interleave">
    <optional>
      <attribute name="text:reference-format">
        <choice>
          <value>page</value>
          <value>chapter</value>
          <value>text</value>
          <value>direction</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.sequence-ref">
    <element name="text:sequence-ref">
      <ref name="text.sequence-ref-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sequence-ref"/>
  </define>
  <define name="text.sequence-ref-attlist" combine="interleave">
    <attribute name="text:ref-name">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.sequence-ref-attlist" combine="interleave">
    <optional>
      <attribute name="text:reference-format">
        <choice>
          <value>page</value>
          <value>chapter</value>
          <value>text</value>
          <value>direction</value>
          <value>category-and-value</value>
          <value>caption</value>
          <value>value</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.bookmark-ref">
    <element name="text:bookmark-ref">
      <ref name="text.bookmark-ref-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.bookmark-ref"/>
  </define>
  <define name="text.bookmark-ref-attlist" combine="interleave">
    <attribute name="text:ref-name">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.bookmark-ref-attlist" combine="interleave">
    <optional>
      <attribute name="text:reference-format">
        <choice>
          <value>page</value>
          <value>chapter</value>
          <value>text</value>
          <value>direction</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.footnote-ref">
    <element name="text:footnote-ref">
      <ref name="text.footnote-ref-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.footnote-ref"/>
  </define>
  <define name="text.footnote-ref-attlist" combine="interleave">
    <attribute name="text:ref-name">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.footnote-ref-attlist" combine="interleave">
    <optional>
      <attribute name="text:reference-format">
        <choice>
          <value>page</value>
          <value>chapter</value>
          <value>text</value>
          <value>direction</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.endnote-ref">
    <element name="text:endnote-ref">
      <ref name="text.endnote-ref-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.endnote-ref"/>
  </define>
  <define name="text.endnote-ref-attlist" combine="interleave">
    <attribute name="text:ref-name">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.endnote-ref-attlist" combine="interleave">
    <optional>
      <attribute name="text:reference-format">
        <choice>
          <value>page</value>
          <value>chapter</value>
          <value>text</value>
          <value>direction</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.sheet-name">
    <element name="text:sheet-name">
      <ref name="text.sheet-name-attlist"/>
      <text/>
    </element>
  </define>
  <define name="text.sheet-name-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sheet-name"/>
  </define>
  <define name="text.page-count">
    <element name="text:page-count">
      <ref name="text.page-count-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.page-count"/>
  </define>
  <define name="text.page-count-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-format">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.page-count-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-letter-sync" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.paragraph-count">
    <element name="text:paragraph-count">
      <ref name="text.paragraph-count-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.paragraph-count"/>
  </define>
  <define name="text.paragraph-count-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-format">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.paragraph-count-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-letter-sync" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.word-count">
    <element name="text:word-count">
      <ref name="text.word-count-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.word-count"/>
  </define>
  <define name="text.word-count-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-format">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.word-count-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-letter-sync" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.character-count">
    <element name="text:character-count">
      <ref name="text.character-count-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.character-count"/>
  </define>
  <define name="text.character-count-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-format">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.character-count-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-letter-sync" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-count">
    <element name="text:table-count">
      <ref name="text.table-count-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.table-count"/>
  </define>
  <define name="text.table-count-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-format">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-count-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-letter-sync" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.image-count">
    <element name="text:image-count">
      <ref name="text.image-count-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.image-count"/>
  </define>
  <define name="text.image-count-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-format">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.image-count-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-letter-sync" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.object-count">
    <element name="text:object-count">
      <ref name="text.object-count-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.object-count"/>
  </define>
  <define name="text.object-count-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-format">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.object-count-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-letter-sync" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.bibliography-mark">
    <element name="text:bibliography-mark">
      <ref name="text.bibliography-mark-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.bibliography-mark"/>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <attribute name="text:bibliography-type">
      <choice>
        <value>article</value>
        <value>book</value>
        <value>booklet</value>
        <value>conference</value>
        <value>custom1</value>
        <value>custom2</value>
        <value>custom3</value>
        <value>custom4</value>
        <value>custom5</value>
        <value>email</value>
        <value>inbook</value>
        <value>incollection</value>
        <value>inproceedings</value>
        <value>journal</value>
        <value>manual</value>
        <value>mastersthesis</value>
        <value>misc</value>
        <value>phdthesis</value>
        <value>proceedings</value>
        <value>techreport</value>
        <value>unpublished</value>
        <value>www</value>
      </choice>
    </attribute>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:identifier"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:address"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:annote"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:author"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:booktitle"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:chapter"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:edition"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:editor"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:howpublished"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:institution"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:journal"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:month"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:note"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:number"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:organizations"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:pages"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:publisher"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:school"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:series"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:title"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:report-type"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:volume"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:year"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:url"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:custom1"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:custom2"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:custom3"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:custom4"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:custom5"/>
    </optional>
  </define>
  <define name="text.bibliography-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:isbn"/>
    </optional>
  </define>
  <define name="text.bookmark">
    <element name="text:bookmark">
      <ref name="text.bookmark-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.bookmark"/>
  </define>
  <define name="text.bookmark-attlist" combine="interleave">
    <attribute name="text:name"/>
  </define>
  <define name="text.bookmark-start">
    <element name="text:bookmark-start">
      <ref name="text.bookmark-start-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.bookmark-start"/>
  </define>
  <define name="text.bookmark-start-attlist" combine="interleave">
    <attribute name="text:name"/>
  </define>
  <define name="text.bookmark-end">
    <element name="text:bookmark-end">
      <ref name="text.bookmark-end-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.bookmark-end"/>
  </define>
  <define name="text.bookmark-end-attlist" combine="interleave">
    <attribute name="text:name"/>
  </define>
  <define name="text.reference-mark">
    <element name="text:reference-mark">
      <ref name="text.reference-mark-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.reference-mark"/>
  </define>
  <define name="text.reference-mark-attlist" combine="interleave">
    <attribute name="text:name"/>
  </define>
  <define name="text.reference-mark-start">
    <element name="text:reference-mark-start">
      <ref name="text.reference-mark-start-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.reference-mark-start"/>
  </define>
  <define name="text.reference-mark-start-attlist" combine="interleave">
    <attribute name="text:name"/>
  </define>
  <define name="text.reference-mark-end">
    <element name="text:reference-mark-end">
      <ref name="text.reference-mark-end-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.reference-mark-end"/>
  </define>
  <define name="text.reference-mark-end-attlist" combine="interleave">
    <attribute name="text:name"/>
  </define>
  <define name="text.footnotes-configuration">
    <element name="text:footnotes-configuration">
      <ref name="text.footnotes-configuration-attlist"/>
      <optional>
        <ref name="text.footnote-continuation-notice-forward"/>
      </optional>
      <optional>
        <ref name="text.footnote-continuation-notice-backward"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.footnotes-configuration"/>
  </define>
  <define name="text.footnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-prefix">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.footnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-suffix">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.footnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-format">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.footnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-letter-sync">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.footnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:citation-body-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.footnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:citation-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.footnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:default-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.footnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:master-page-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.footnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:start-value">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="text.footnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:footnotes-position" a:defaultValue="page">
        <choice>
          <value>document</value>
          <value>page</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.footnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:start-numbering-at" a:defaultValue="document">
        <choice>
          <value>document</value>
          <value>chapter</value>
          <value>page</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.footnote-continuation-notice-forward">
    <element name="text:footnote-continuation-notice-forward">
      <ref name="text.footnote-continuation-notice-forward-attlist"/>
      <text/>
    </element>
  </define>
  <define name="text.footnote-continuation-notice-forward-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.footnote-continuation-notice-forward"/>
  </define>
  <define name="text.footnote-continuation-notice-backward">
    <element name="text:footnote-continuation-notice-backward">
      <ref name="text.footnote-continuation-notice-backward-attlist"/>
      <text/>
    </element>
  </define>
  <define name="text.footnote-continuation-notice-backward-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.footnote-continuation-notice-backward"/>
  </define>
  <define name="text.endnotes-configuration">
    <element name="text:endnotes-configuration">
      <ref name="text.endnotes-configuration-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.endnotes-configuration"/>
  </define>
  <define name="text.endnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-prefix">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.endnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-suffix">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.endnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-format">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.endnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-letter-sync">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.endnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:start-value">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="text.endnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:citation-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.endnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:citation-body-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.endnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:default-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.endnotes-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:master-page-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
<!-- Validity constraint: text:footnote and text:endnote elements may not 
	contain other text:footnote or text:endnote elements, even though the DTD
	allows this (via the %text; in the foot-/endnote-body).
	Unfortunatetly, this constraint cannot be easily specified in the DTD.
-->
  <define name="text.footnote">
    <element name="text:footnote">
      <ref name="text.footnote-attlist"/>
      <ref name="text.footnote-citation"/>
      <ref name="text.footnote-body"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.footnote"/>
  </define>
  <define name="text.footnote-attlist" combine="interleave">
    <optional>
      <attribute name="text:id">
        <data type="ID"/>
      </attribute>
    </optional>
  </define>
  <define name="text.footnote-citation">
    <element name="text:footnote-citation">
      <ref name="text.footnote-citation-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.footnote-citation"/>
  </define>
  <define name="text.footnote-citation-attlist" combine="interleave">
    <optional>
      <attribute name="text:label">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.footnote-body">
    <element name="text:footnote-body">
      <ref name="text.footnote-body-attlist"/>
      <zeroOrMore>
        <choice>
          <ref name="text.h"/>
          <ref name="text.p"/>
          <ref name="text.ordered-list"/>
          <ref name="text.unordered-list"/>
        </choice>
      </zeroOrMore>
    </element>
  </define>
  <define name="text.footnote-body-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.footnote-body"/>
  </define>
  <define name="text.endnote">
    <element name="text:endnote">
      <ref name="text.endnote-attlist"/>
      <ref name="text.endnote-citation"/>
      <ref name="text.endnote-body"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.endnote"/>
  </define>
  <define name="text.endnote-attlist" combine="interleave">
    <optional>
      <attribute name="text:id">
        <data type="ID"/>
      </attribute>
    </optional>
  </define>
  <define name="text.endnote-citation">
    <element name="text:endnote-citation">
      <ref name="text.endnote-citation-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.endnote-citation"/>
  </define>
  <define name="text.endnote-citation-attlist" combine="interleave">
    <optional>
      <attribute name="text:label">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.endnote-body">
    <element name="text:endnote-body">
      <ref name="text.endnote-body-attlist"/>
      <zeroOrMore>
        <choice>
          <ref name="text.h"/>
          <ref name="text.p"/>
          <ref name="text.ordered-list"/>
          <ref name="text.unordered-list"/>
        </choice>
      </zeroOrMore>
    </element>
  </define>
  <define name="text.endnote-body-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.endnote-body"/>
  </define>
  <define name="sectionAttr">
    <attribute name="text:name"/>
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="text:protected" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.section">
    <element name="text:section">
      <ref name="text.section-attlist"/>
      <optional>
        <choice>
          <ref name="text.section-source"/>
          <ref name="office.dde-source"/>
        </choice>
      </optional>
      <ref name="sectionText"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.section"/>
  </define>
  <define name="text.section-attlist" combine="interleave">
    <ref name="sectionAttr"/>
  </define>
  <define name="text.section-attlist" combine="interleave">
    <optional>
      <attribute name="text:display" a:defaultValue="true">
        <choice>
          <value>true</value>
          <value>none</value>
          <value>condition</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.section-attlist" combine="interleave">
    <optional>
      <attribute name="text:condition">
        <ref name="formula"/>
      </attribute>
    </optional>
  </define>
  <define name="text.section-attlist" combine="interleave">
    <optional>
      <attribute name="text:protection-key"/>
    </optional>
  </define>
  <define name="text.section-attlist" combine="interleave">
    <optional>
      <attribute name="text:is-hidden">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.section-source">
    <element name="text:section-source">
      <ref name="text.section-source-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.section-source"/>
  </define>
  <define name="text.section-source-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:href">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.section-source-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type" a:defaultValue="simple">
        <value>simple</value>
      </attribute>
    </optional>
  </define>
  <define name="text.section-source-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show" a:defaultValue="embed">
        <value>embed</value>
      </attribute>
    </optional>
  </define>
  <define name="text.section-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:section-name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.section-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:filter-name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-of-content">
    <element name="text:table-of-content">
      <ref name="text.table-of-content-attlist"/>
      <ref name="text.table-of-content-source"/>
      <ref name="text.index-body"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.table-of-content"/>
  </define>
  <define name="text.table-of-content-attlist" combine="interleave">
    <ref name="sectionAttr"/>
  </define>
  <define name="text.table-of-content-source">
    <element name="text:table-of-content-source">
      <ref name="text.table-of-content-source-attlist"/>
      <optional>
        <ref name="text.index-title-template"/>
      </optional>
      <zeroOrMore>
        <ref name="text.table-of-content-entry-template"/>
      </zeroOrMore>
      <zeroOrMore>
        <ref name="text.index-source-styles"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.table-of-content-source"/>
  </define>
  <define name="text.table-of-content-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:outline-level">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-of-content-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-index-marks" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-of-content-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-index-source-styles" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-of-content-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:index-scope" a:defaultValue="document">
        <choice>
          <value>document</value>
          <value>chapter</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.table-of-content-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:relative-tab-stop-position" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-of-content-source-attlist" combine="interleave">
    <optional>
      <attribute name="fo:language">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-of-content-source-attlist" combine="interleave">
    <optional>
      <attribute name="fo:country">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-of-content-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:sort-algorithm">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-of-content-entry-template">
    <element name="text:table-of-content-entry-template">
      <ref name="text.table-of-content-entry-template-attlist"/>
      <zeroOrMore>
        <choice>
          <ref name="text.index-entry-chapter-number"/>
          <ref name="text.index-entry-page-number"/>
          <ref name="text.index-entry-text"/>
          <ref name="text.index-entry-span"/>
          <ref name="text.index-entry-tab-stop"/>
          <ref name="text.index-entry-link-start"/>
          <ref name="text.index-entry-link-end"/>
        </choice>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.table-of-content-entry-template"/>
  </define>
  <define name="text.table-of-content-entry-template-attlist" combine="interleave">
    <attribute name="text:outline-level">
      <ref name="integer"/>
    </attribute>
  </define>
  <define name="text.table-of-content-entry-template-attlist" combine="interleave">
    <attribute name="text:style-name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="text.illustration-index">
    <element name="text:illustration-index">
      <ref name="text.illustration-index-attlist"/>
      <ref name="text.illustration-index-source"/>
      <ref name="text.index-body"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.illustration-index"/>
  </define>
  <define name="text.illustration-index-attlist" combine="interleave">
    <ref name="sectionAttr"/>
  </define>
  <define name="text.illustration-index-source">
    <element name="text:illustration-index-source">
      <ref name="text.illustration-index-source-attlist"/>
      <optional>
        <ref name="text.index-title-template"/>
      </optional>
      <optional>
        <ref name="text.illustration-index-entry-template"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.illustration-index-source"/>
  </define>
  <define name="text.illustration-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:index-scope" a:defaultValue="document">
        <choice>
          <value>document</value>
          <value>chapter</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.illustration-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:relative-tab-stop-position" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.illustration-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-caption" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.illustration-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:caption-sequence-name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.illustration-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:caption-sequence-format" a:defaultValue="text">
        <choice>
          <value>text</value>
          <value>category-and-value</value>
          <value>caption</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.illustration-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="fo:language">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.illustration-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="fo:country">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.illustration-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:sort-algorithm">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.illustration-index-entry-template">
    <element name="text:illustration-index-entry-template">
      <ref name="text.illustration-index-entry-template-attlist"/>
      <zeroOrMore>
        <choice>
          <ref name="text.index-entry-page-number"/>
          <ref name="text.index-entry-text"/>
          <ref name="text.index-entry-span"/>
          <ref name="text.index-entry-tab-stop"/>
        </choice>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.illustration-index-entry-template"/>
  </define>
  <define name="text.illustration-index-entry-template-attlist" combine="interleave">
    <attribute name="text:style-name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="text.table-index">
    <element name="text:table-index">
      <ref name="text.table-index-attlist"/>
      <ref name="text.table-index-source"/>
      <ref name="text.index-body"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.table-index"/>
  </define>
  <define name="text.table-index-attlist" combine="interleave">
    <ref name="sectionAttr"/>
  </define>
  <define name="text.table-index-source">
    <element name="text:table-index-source">
      <ref name="text.table-index-source-attlist"/>
      <optional>
        <ref name="text.index-title-template"/>
      </optional>
      <optional>
        <ref name="text.table-index-entry-template"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.table-index-source"/>
  </define>
  <define name="text.table-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:index-scope" a:defaultValue="document">
        <choice>
          <value>document</value>
          <value>chapter</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.table-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:relative-tab-stop-position" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-caption" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:caption-sequence-name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:caption-sequence-format" a:defaultValue="text">
        <choice>
          <value>text</value>
          <value>category-and-value</value>
          <value>caption</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.table-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="fo:language">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="fo:country">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:sort-algorithm">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.table-index-entry-template">
    <element name="text:table-index-entry-template">
      <ref name="text.table-index-entry-template-attlist"/>
      <zeroOrMore>
        <choice>
          <ref name="text.index-entry-page-number"/>
          <ref name="text.index-entry-text"/>
          <ref name="text.index-entry-span"/>
          <ref name="text.index-entry-tab-stop"/>
        </choice>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.table-index-entry-template"/>
  </define>
  <define name="text.table-index-entry-template-attlist" combine="interleave">
    <attribute name="text:style-name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="text.object-index">
    <element name="text:object-index">
      <ref name="text.object-index-attlist"/>
      <ref name="text.object-index-source"/>
      <ref name="text.index-body"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.object-index"/>
  </define>
  <define name="text.object-index-attlist" combine="interleave">
    <ref name="sectionAttr"/>
  </define>
  <define name="text.object-index-source">
    <element name="text:object-index-source">
      <ref name="text.object-index-source-attlist"/>
      <optional>
        <ref name="text.index-title-template"/>
      </optional>
      <optional>
        <ref name="text.object-index-entry-template"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.object-index-source"/>
  </define>
  <define name="text.object-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:index-scope" a:defaultValue="document">
        <choice>
          <value>document</value>
          <value>chapter</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.object-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:relative-tab-stop-position" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.object-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-spreadsheet-objects" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.object-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-draw-objects" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.object-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-chart-objects" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.object-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-other-objects" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.object-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-math-objects" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.object-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="fo:language">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.object-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="fo:country">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.object-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:sort-algorithm">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.object-index-entry-template">
    <element name="text:object-index-entry-template">
      <ref name="text.object-index-entry-template-attlist"/>
      <zeroOrMore>
        <choice>
          <ref name="text.index-entry-page-number"/>
          <ref name="text.index-entry-text"/>
          <ref name="text.index-entry-span"/>
          <ref name="text.index-entry-tab-stop"/>
        </choice>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.object-index-entry-template"/>
  </define>
  <define name="text.object-index-entry-template-attlist" combine="interleave">
    <attribute name="text:style-name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="text.user-index">
    <element name="text:user-index">
      <ref name="text.user-index-attlist"/>
      <ref name="text.user-index-source"/>
      <ref name="text.index-body"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.user-index"/>
  </define>
  <define name="text.user-index-attlist" combine="interleave">
    <ref name="sectionAttr"/>
  </define>
  <define name="text.user-index-source">
    <element name="text:user-index-source">
      <ref name="text.user-index-source-attlist"/>
      <optional>
        <ref name="text.index-title-template"/>
      </optional>
      <zeroOrMore>
        <ref name="text.user-index-entry-template"/>
      </zeroOrMore>
      <zeroOrMore>
        <ref name="text.index-source-styles"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.user-index-source"/>
  </define>
  <define name="text.user-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:index-scope" a:defaultValue="document">
        <choice>
          <value>document</value>
          <value>chapter</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:relative-tab-stop-position" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-index-marks" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-graphics" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-tables" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-floating-frames" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-objects" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-index-source-styles" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:copy-outline-levels" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="fo:language">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="fo:country">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:sort-algorithm">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:index-name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-entry-template">
    <element name="text:user-index-entry-template">
      <ref name="text.user-index-entry-template-attlist"/>
      <zeroOrMore>
        <choice>
          <ref name="text.index-entry-chapter"/>
          <ref name="text.index-entry-page-number"/>
          <ref name="text.index-entry-text"/>
          <ref name="text.index-entry-span"/>
          <ref name="text.index-entry-tab-stop"/>
        </choice>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.user-index-entry-template"/>
  </define>
  <define name="text.user-index-entry-template-attlist" combine="interleave">
    <attribute name="text:outline-level">
      <ref name="integer"/>
    </attribute>
  </define>
  <define name="text.user-index-entry-template-attlist" combine="interleave">
    <attribute name="text:style-name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="text.alphabetical-index">
    <element name="text:alphabetical-index">
      <ref name="text.alphabetical-index-attlist"/>
      <ref name="text.alphabetical-index-source"/>
      <ref name="text.index-body"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.alphabetical-index"/>
  </define>
  <define name="text.alphabetical-index-attlist" combine="interleave">
    <ref name="sectionAttr"/>
  </define>
  <define name="text.alphabetical-index-source">
    <element name="text:alphabetical-index-source">
      <ref name="text.alphabetical-index-source-attlist"/>
      <optional>
        <ref name="text.index-title-template"/>
      </optional>
      <zeroOrMore>
        <ref name="text.alphabetical-index-entry-template"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.alphabetical-index-source"/>
  </define>
  <define name="text.alphabetical-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:index-scope" a:defaultValue="document">
        <choice>
          <value>document</value>
          <value>chapter</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:relative-tab-stop-position" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:ignore-case" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:main-entry-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:alphabetical-separators" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:combine-entries" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:combine-entries-with-dash" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:combine-entries-with-pp" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:use-keys-as-entries" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:capitalize-entries" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:comma-separated" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="fo:language">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="fo:country">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-source-attlist" combine="interleave">
    <optional>
      <attribute name="text:sort-algorithm">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-entry-template">
    <element name="text:alphabetical-index-entry-template">
      <ref name="text.alphabetical-index-entry-template-attlist"/>
      <zeroOrMore>
        <choice>
          <ref name="text.index-entry-chapter"/>
          <ref name="text.index-entry-page-number"/>
          <ref name="text.index-entry-text"/>
          <ref name="text.index-entry-span"/>
          <ref name="text.index-entry-tab-stop"/>
        </choice>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.alphabetical-index-entry-template"/>
  </define>
  <define name="text.alphabetical-index-entry-template-attlist" combine="interleave">
    <attribute name="text:outline-level">
      <choice>
        <value>1</value>
        <value>2</value>
        <value>3</value>
        <value>separator</value>
      </choice>
    </attribute>
  </define>
  <define name="text.alphabetical-index-entry-template-attlist" combine="interleave">
    <attribute name="text:style-name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="text.alphabetical-index-auto-mark-file">
    <element name="text:alphabetical-index-auto-mark-file">
      <ref name="text.alphabetical-index-auto-mark-file-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.alphabetical-index-auto-mark-file"/>
  </define>
  <define name="text.alphabetical-index-auto-mark-file-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:href"/>
    </optional>
  </define>
  <define name="text.alphabetical-index-auto-mark-file-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type" a:defaultValue="simple">
        <value>simple</value>
      </attribute>
    </optional>
  </define>
  <define name="text.bibliography">
    <element name="text:bibliography">
      <ref name="text.bibliography-attlist"/>
      <ref name="text.bibliography-source"/>
      <ref name="text.index-body"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.bibliography"/>
  </define>
  <define name="text.bibliography-attlist" combine="interleave">
    <ref name="sectionAttr"/>
  </define>
  <define name="text.bibliography-source">
    <element name="text:bibliography-source">
      <ref name="text.bibliography-source-attlist"/>
      <optional>
        <ref name="text.index-title-template"/>
      </optional>
      <zeroOrMore>
        <ref name="text.bibliography-entry-template"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="text.bibliography-source-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.bibliography-source"/>
  </define>
  <define name="text.bibliography-entry-template">
    <element name="text:bibliography-entry-template">
      <ref name="text.bibliography-entry-template-attlist"/>
      <zeroOrMore>
        <choice>
          <ref name="text.index-entry-span"/>
          <ref name="text.index-entry-tab-stop"/>
          <ref name="text.index-entry-bibliography"/>
        </choice>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.bibliography-entry-template"/>
  </define>
  <define name="text.bibliography-entry-template-attlist" combine="interleave">
    <attribute name="text:bibliography-type">
      <choice>
        <value>article</value>
        <value>book</value>
        <value>booklet</value>
        <value>conference</value>
        <value>custom1</value>
        <value>custom2</value>
        <value>custom3</value>
        <value>custom4</value>
        <value>custom5</value>
        <value>email</value>
        <value>inbook</value>
        <value>incollection</value>
        <value>inproceedings</value>
        <value>journal</value>
        <value>manual</value>
        <value>mastersthesis</value>
        <value>misc</value>
        <value>phdthesis</value>
        <value>proceedings</value>
        <value>techreport</value>
        <value>unpublished</value>
        <value>www</value>
      </choice>
    </attribute>
  </define>
  <define name="text.bibliography-entry-template-attlist" combine="interleave">
    <attribute name="text:style-name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="text.index-body">
    <element name="text:index-body">
      <ref name="text.index-body-attlist"/>
      <ref name="sectionText"/>
    </element>
  </define>
  <define name="text.index-body-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.index-body"/>
  </define>
<!-- 
Validity constraint: text:index-title elements may appear only in
indices, and there may be only one text:index-title element.  
-->
  <define name="text.index-title">
    <element name="text:index-title">
      <ref name="text.index-title-attlist"/>
      <ref name="sectionText"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.index-title"/>
  </define>
  <define name="text.index-title-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.index-title-attlist" combine="interleave">
    <optional>
      <attribute name="text:name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.index-title-template">
    <element name="text:index-title-template">
      <ref name="text.index-title-template-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.index-title-template"/>
  </define>
  <define name="text.index-title-template-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.index-entry-chapter-number">
    <element name="text:index-entry-chapter-number">
      <ref name="text.index-entry-chapter-number-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.index-entry-chapter-number"/>
  </define>
  <define name="text.index-entry-chapter-number-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.index-entry-chapter">
    <element name="text:index-entry-chapter">
      <ref name="text.index-entry-chapter-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.index-entry-chapter"/>
  </define>
  <define name="text.index-entry-chapter-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.index-entry-chapter-attlist" combine="interleave">
    <optional>
      <attribute name="text:display" a:defaultValue="number-and-name">
        <choice>
          <value>name</value>
          <value>number</value>
          <value>number-and-name</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.index-entry-text">
    <element name="text:index-entry-text">
      <ref name="text.index-entry-text-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.index-entry-text"/>
  </define>
  <define name="text.index-entry-text-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.index-entry-page-number">
    <element name="text:index-entry-page-number">
      <ref name="text.index-entry-page-number-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.index-entry-page-number"/>
  </define>
  <define name="text.index-entry-page-number-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.index-entry-span">
    <element name="text:index-entry-span">
      <ref name="text.index-entry-span-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.index-entry-span"/>
  </define>
  <define name="text.index-entry-span-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.index-entry-bibliography">
    <element name="text:index-entry-bibliography">
      <ref name="text.index-entry-bibliography-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.index-entry-bibliography"/>
  </define>
  <define name="text.index-entry-bibliography-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.index-entry-bibliography-attlist" combine="interleave">
    <attribute name="text:bibliography-data-field">
      <choice>
        <value>address</value>
        <value>annote</value>
        <value>author</value>
        <value>bibliography-type</value>
        <value>booktitle</value>
        <value>chapter</value>
        <value>custom1</value>
        <value>custom2</value>
        <value>custom3</value>
        <value>custom4</value>
        <value>custom5</value>
        <value>edition</value>
        <value>editor</value>
        <value>howpublished</value>
        <value>identifier</value>
        <value>institution</value>
        <value>isbn</value>
        <value>journal</value>
        <value>month</value>
        <value>note</value>
        <value>number</value>
        <value>organizations</value>
        <value>pages</value>
        <value>publisher</value>
        <value>report-type</value>
        <value>school</value>
        <value>series</value>
        <value>title</value>
        <value>url</value>
        <value>volume</value>
        <value>year</value>
      </choice>
    </attribute>
  </define>
  <define name="text.index-entry-tab-stop">
    <element name="text:index-entry-tab-stop">
      <ref name="text.index-entry-tab-stop-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.index-entry-tab-stop"/>
  </define>
  <define name="text.index-entry-tab-stop-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.index-entry-tab-stop-attlist" combine="interleave">
    <optional>
      <attribute name="style:leader-char" a:defaultValue=" ">
        <ref name="character"/>
      </attribute>
    </optional>
  </define>
  <define name="text.index-entry-tab-stop-attlist" combine="interleave">
    <optional>
      <attribute name="style:type" a:defaultValue="left">
        <choice>
          <value>left</value>
          <value>right</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.index-entry-tab-stop-attlist" combine="interleave">
    <optional>
      <attribute name="style:position">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="text.index-entry-link-start">
    <element name="text:index-entry-link-start">
      <ref name="text.index-entry-link-start-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.index-entry-link-start"/>
  </define>
  <define name="text.index-entry-link-start-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.index-entry-link-end">
    <element name="text:index-entry-link-end">
      <ref name="text.index-entry-link-end-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.index-entry-link-end"/>
  </define>
  <define name="text.index-entry-link-end-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.index-source-styles">
    <element name="text:index-source-styles">
      <ref name="text.index-source-styles-attlist"/>
      <zeroOrMore>
        <ref name="text.index-source-style"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.index-source-styles"/>
  </define>
  <define name="text.index-source-styles-attlist" combine="interleave">
    <attribute name="text:outline-level">
      <ref name="integer"/>
    </attribute>
  </define>
  <define name="text.index-source-style">
    <element name="text:index-source-style">
      <ref name="text.index-source-style-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.index-source-style"/>
  </define>
  <define name="text.index-source-style-attlist" combine="interleave">
    <attribute name="text:style-name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="text.toc-mark-start">
    <element name="text:toc-mark-start">
      <ref name="text.toc-mark-start-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.toc-mark-start"/>
  </define>
  <define name="text.toc-mark-start-attlist" combine="interleave">
    <attribute name="text:id">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.toc-mark-start-attlist" combine="interleave">
    <optional>
      <attribute name="text:outline-level">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="text.toc-mark-end">
    <element name="text:toc-mark-end">
      <ref name="text.toc-mark-end-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.toc-mark-end"/>
  </define>
  <define name="text.toc-mark-end-attlist" combine="interleave">
    <attribute name="text:id">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.toc-mark">
    <element name="text:toc-mark">
      <ref name="text.toc-mark-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.toc-mark"/>
  </define>
  <define name="text.toc-mark-attlist" combine="interleave">
    <attribute name="text:string-value">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.toc-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:outline-level">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-mark-start">
    <element name="text:user-index-mark-start">
      <ref name="text.user-index-mark-start-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.user-index-mark-start"/>
  </define>
  <define name="text.user-index-mark-start-attlist" combine="interleave">
    <attribute name="text:id">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.user-index-mark-start-attlist" combine="interleave">
    <optional>
      <attribute name="text:outline-level">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-mark-start-attlist" combine="interleave">
    <optional>
      <attribute name="text:index-name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-mark-end">
    <element name="text:user-index-mark-end">
      <ref name="text.user-index-mark-end-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.user-index-mark-end"/>
  </define>
  <define name="text.user-index-mark-end-attlist" combine="interleave">
    <attribute name="text:id">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.user-index-mark">
    <element name="text:user-index-mark">
      <ref name="text.user-index-mark-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.user-index-mark"/>
  </define>
  <define name="text.user-index-mark-attlist" combine="interleave">
    <attribute name="text:string-value">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.user-index-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:outline-level">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="text.user-index-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:index-name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-mark-start">
    <element name="text:alphabetical-index-mark-start">
      <ref name="text.alphabetical-index-mark-start-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.alphabetical-index-mark-start"/>
  </define>
  <define name="text.alphabetical-index-mark-start-attlist" combine="interleave">
    <attribute name="text:id">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.alphabetical-index-mark-start-attlist" combine="interleave">
    <optional>
      <attribute name="text:key1">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-mark-start-attlist" combine="interleave">
    <optional>
      <attribute name="text:key2">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-mark-start-attlist" combine="interleave">
    <optional>
      <attribute name="text:main-etry" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-mark-end">
    <element name="text:alphabetical-index-mark-end">
      <ref name="text.alphabetical-index-mark-end-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.alphabetical-index-mark-end"/>
  </define>
  <define name="text.alphabetical-index-mark-end-attlist" combine="interleave">
    <attribute name="text:id">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.alphabetical-index-mark">
    <element name="text:alphabetical-index-mark">
      <ref name="text.alphabetical-index-mark-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.alphabetical-index-mark"/>
  </define>
  <define name="text.alphabetical-index-mark-attlist" combine="interleave">
    <attribute name="text:string-value">
      <ref name="string"/>
    </attribute>
  </define>
  <define name="text.alphabetical-index-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:key1">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:key2">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.alphabetical-index-mark-attlist" combine="interleave">
    <optional>
      <attribute name="text:main-etry" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.bibliography-configuration">
    <element name="text:bibliography-configuration">
      <ref name="text.bibliography-configuration-attlist"/>
      <zeroOrMore>
        <ref name="text.sort-key"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.bibliography-configuration"/>
  </define>
  <define name="text.bibliography-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:prefix">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.bibliography-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:suffix">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.bibliography-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:sort-by-position" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.bibliography-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:numbered-entries" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.bibliography-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="fo:language">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.bibliography-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="fo:country">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.bibliography-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:sort-algorithm">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="text.sort-key">
    <element name="text:sort-key">
      <ref name="text.sort-key-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.sort-key"/>
  </define>
  <define name="text.sort-key-attlist" combine="interleave">
    <attribute name="text:key">
      <choice>
        <value>address</value>
        <value>annote</value>
        <value>author</value>
        <value>bibliography-type</value>
        <value>booktitle</value>
        <value>chapter</value>
        <value>custom1</value>
        <value>custom2</value>
        <value>custom3</value>
        <value>custom4</value>
        <value>custom5</value>
        <value>edition</value>
        <value>editor</value>
        <value>howpublished</value>
        <value>identifier</value>
        <value>institution</value>
        <value>isbn</value>
        <value>journal</value>
        <value>month</value>
        <value>note</value>
        <value>number</value>
        <value>organizations</value>
        <value>pages</value>
        <value>publisher</value>
        <value>report-type</value>
        <value>school</value>
        <value>series</value>
        <value>title</value>
        <value>url</value>
        <value>volume</value>
        <value>year</value>
      </choice>
    </attribute>
  </define>
  <define name="text.sort-key-attlist" combine="interleave">
    <optional>
      <attribute name="text:sort-ascending" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.linenumbering-configuration">
    <element name="text:linenumbering-configuration">
      <ref name="text.linenumbering-configuration-attlist"/>
      <optional>
        <ref name="text.linenumbering-separator"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.linenumbering-configuration"/>
  </define>
  <define name="text.linenumbering-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.linenumbering-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:number-lines" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.linenumbering-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:count-empty-lines" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.linenumbering-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:count-in-floating-frames" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.linenumbering-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:restart-numbering" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.linenumbering-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:offset">
        <ref name="nonNegativeLength"/>
      </attribute>
    </optional>
  </define>
  <define name="text.linenumbering-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-format" a:defaultValue="1">
        <choice>
          <value>1</value>
          <value>a</value>
          <value>A</value>
          <value>i</value>
          <value>I</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.linenumbering-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="style:num-letter-sync" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.linenumbering-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:number-position" a:defaultValue="left">
        <choice>
          <value>left</value>
          <value>rigth</value>
          <value>inner</value>
          <value>outer</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="text.linenumbering-configuration-attlist" combine="interleave">
    <optional>
      <attribute name="text:increment">
        <ref name="nonNegativeInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="text.linenumbering-separator">
    <element name="text:linenumbering-separator">
      <ref name="text.linenumbering-separator-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.linenumbering-separator"/>
  </define>
  <define name="text.linenumbering-separator-attlist" combine="interleave">
    <optional>
      <attribute name="text:increment">
        <ref name="nonNegativeInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="text.script">
    <element name="text:script">
      <ref name="text.script-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.script"/>
  </define>
  <define name="text.script-attlist" combine="interleave">
    <attribute name="script:language"/>
  </define>
  <define name="text.script-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:href"/>
    </optional>
  </define>
  <define name="text.script-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type" a:defaultValue="simple">
        <value>simple</value>
      </attribute>
    </optional>
  </define>
  <define name="text.measure">
    <element name="text:measure">
      <ref name="text.measure-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.measure"/>
  </define>
  <define name="text.measure-attlist" combine="interleave">
    <attribute name="text:kind">
      <choice>
        <value>value</value>
        <value>unit</value>
        <value>gap</value>
      </choice>
    </attribute>
  </define>
  <define name="text.ruby">
    <element name="text:ruby">
      <ref name="text.ruby-attlist"/>
      <ref name="text.ruby-base"/>
      <ref name="text.ruby-text"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.ruby"/>
  </define>
  <define name="text.ruby-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text.ruby-base">
    <element name="text:ruby-base">
      <ref name="text.ruby-base-attlist"/>
      <ref name="inline-text"/>
    </element>
  </define>
  <define name="text.ruby-base-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.ruby-base"/>
  </define>
  <define name="text.ruby-text">
    <element name="text:ruby-text">
      <ref name="text.ruby-text-attlist"/>
      <text/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.ruby-text"/>
  </define>
  <define name="text.ruby-text-attlist" combine="interleave">
    <optional>
      <attribute name="text:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
<!-- elements for change tracking -->
  <define name="text.change">
    <element name="text:change">
      <ref name="text.change-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.change"/>
  </define>
  <define name="text.change-attlist" combine="interleave">
    <attribute name="text:change-id"/>
  </define>
  <define name="text.change-start">
    <element name="text:change-start">
      <ref name="text.change-start-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.change-start"/>
  </define>
  <define name="text.change-start-attlist" combine="interleave">
    <attribute name="text:change-id"/>
  </define>
  <define name="text.change-end">
    <element name="text:change-end">
      <ref name="text.change-end-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.change-end"/>
  </define>
  <define name="text.change-end-attlist" combine="interleave">
    <attribute name="text:change-id"/>
  </define>
  <define name="text.tracked-changes">
    <element name="text:tracked-changes">
      <ref name="text.tracked-changes-attlist"/>
      <zeroOrMore>
        <ref name="text.changed-region"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.tracked-changes"/>
  </define>
  <define name="text.tracked-changes-attlist" combine="interleave">
    <optional>
      <attribute name="text:track-changes" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.tracked-changes-attlist" combine="interleave">
    <optional>
      <attribute name="text:protection-key"/>
    </optional>
  </define>
  <define name="text.changed-region">
    <element name="text:changed-region">
      <ref name="text.changed-region-attlist"/>
      <choice>
        <ref name="text.insertion"/>
        <group>
          <ref name="text.deletion"/>
          <optional>
            <ref name="text.insertion"/>
          </optional>
        </group>
        <ref name="text.format-change"/>
      </choice>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="text.changed-region"/>
  </define>
  <define name="text.changed-region-attlist" combine="interleave">
    <attribute name="text:id">
      <data type="ID"/>
    </attribute>
  </define>
  <define name="text.changed-region-attlist" combine="interleave">
    <optional>
      <attribute name="text:merge-last-paragraph" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="text.insertion">
    <element name="text:insertion">
      <ref name="text.insertion-attlist"/>
      <ref name="office.change-info"/>
      <ref name="sectionText"/>
    </element>
  </define>
  <define name="text.insertion-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.insertion"/>
  </define>
  <define name="text.deletion">
    <element name="text:deletion">
      <ref name="text.deletion-attlist"/>
      <ref name="office.change-info"/>
      <ref name="sectionText"/>
    </element>
  </define>
  <define name="text.deletion-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.deletion"/>
  </define>
  <define name="text.format-change">
    <element name="text:format-change">
      <ref name="text.format-change-attlist"/>
      <ref name="office.change-info"/>
    </element>
  </define>
  <define name="text.format-change-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="text.format-change"/>
  </define>
</grammar>
